//+------------------------------------------------------------------+
//|                                                  VNetSigFeed.mq4 |
//|                                     Copyright 2013, Ralph Ritoch |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, Ralph Ritoch"
#property link      "http://www.metaquotes.net"


#include <mt4_winhttp.mqh>

string app_version = "1.00020";
double current_rates[][6];
string current_symbol;
int current_period;

int sv_done = 0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

int init()
  {
  
  int hSession;
  int hConnect;
  int hRequest;
  
  int rslt;
  int rlen;
  int bytesRead;
    
  string httpResult;
  string url;
   
//----
   Print("[VNetSigFeed] init() called v",app_version);
   
   
   hSession = winhttp_WinHttpOpen(  "A WinHTTP Example Program/1.0", 
                             0,
                             WINHTTP_NO_PROXY_NAME, 
                             WINHTTP_NO_PROXY_BYPASS, 0);
    
   if (hSession < 0) {
        Print("WinHttpOpen Error: ", winhttp_GetLastError());
   }        
     // Use WinHttpQueryOption to retrieve Internet options.
    
     httpResult = winhttp_WinHttpQueryOption(0, hSession, WINHTTP_OPTION_CONNECT_TIMEOUT);
                  
     Print("httpResult = ",httpResult);
    
    
   
 
    // Use WinHttpConnect to specify an HTTP server.
    hConnect = winhttp_WinHttpConnect( hSession, "127.0.0.1",
                               INTERNET_DEFAULT_HTTP_PORT);
 

   if (hConnect < 0) {
        Print("WinHttpConnect Error: ", winhttp_GetLastError());
   }  
 
    // Open and Send a Request Header.          
    hRequest = winhttp_WinHttpOpenRequest( hConnect, "POST", 
                         "/apps/ReceiveForexSignal.php", 
                         "", 
                         WINHTTP_NO_REFERER, 
                         0
    );                     

    if (hRequest < 0) {
        Print("WinHttpOpenRequest Error: ", winhttp_GetLastError());
    }
    
    rslt = winhttp_AppendRequestData(hRequest,"test=OK");
            
    rslt = winhttp_WinHttpSendRequest( hRequest, "Content-Type: application/x-www-form-urlencoded");
    
    if (rslt < 1) {
         Print("Send Request Error: ", winhttp_GetLastError());
    } else {
    
        rslt = winhttp_WinHttpReceiveResponse( hRequest);
   
       Print("Receive Response: ",rslt);
                
        url = winhttp_WinHttpQueryOption(0, hRequest, WINHTTP_OPTION_URL);
        
        Print("URL: ",url);
      
        bytesRead = winhttp_WinHttpQryDataAvailable(hRequest);
  
        if (bytesRead >= 0) {
            Print("Bytes Read: ",bytesRead);
    
            httpResult = winhttp_WinHttpReadData(hRequest);
            while(StringLen(httpResult) > 0) {
                Print("Read: ",httpResult);
                httpResult = winhttp_WinHttpReadData(hRequest);
            }  
        } else {
            Print("winhttp_WinHttpQryDataAvailable Error ",bytesRead, " : ",winhttp_GetLastError());
        }
  
    }
    // When finished, release the hRequest handle.
    rslt = winhttp_WinHttpCloseHandle(hRequest);
    if (!rslt) {
        Print("Could not close the hRequest handle.\n");
	 }
 
    // When finished, release the hConnect handle.
    rslt = winhttp_WinHttpCloseHandle(hConnect);
    if (!rslt) {
        Print("Could not close the hConnect handle.\n");
     }   
         
    winhttp_WinHttpCloseHandle(hSession);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
    
//----
   Print("[VNetSigFeed] deinit() called");
   
   
   
      
   
//----
   return(0);
  }
  
void fetchRates(string symbol, int period) 
{
    int err;
    ArrayCopyRates(current_rates,symbol,period);    
    err = GetLastError();    
    while (err == 4066) {
        ArrayCopyRates(current_rates,symbol,period);    
        err = GetLastError();        
    }
    current_symbol = symbol;
    current_period = period;
    return;
}

int createCSV(string filename) {
     
     string period_str;
     int handle;
     int sz;
     int idx;
     string symbol;
     
     int ret = 0;
     
     datetime orderOpen=OrderOpenTime();        
     string company = AccountCompany();
     
     
     period_str = period2str(current_period);
     symbol = current_symbol;
         
     handle=FileOpen(filename, FILE_CSV|FILE_WRITE, ',');
     if(handle>0){ 
         ret = 1;        
         sz = ArraySize(current_rates);
         
         FileWrite(handle, "Company","Symbol","Period","Time","Open","High","Low","Close","Volume");
         
         for(idx=sz-1;sz>-1;idx--) {
             if (current_rates[idx][0] > 0) {
             FileWrite(handle, 
                 company, 
                 symbol, 
                 period_str, 
                 TimeToStr(current_rates[idx][0]),
                 current_rates[idx][1],
                 current_rates[idx][3],
                 current_rates[idx][2],
                 current_rates[idx][4],
                 current_rates[idx][5]
             );
             }
         }
         FileClose(handle);
         Print("File save complete");
    } else {
        Print("Failed to open file");
    }     
    return (ret);
}

string period2str(int period) {
    string str;
    
    switch(period) {
        case PERIOD_MN1:
             str = "MN1";
             break;
        case PERIOD_W1:
             str = "W1";
             break;    
        case PERIOD_D1:
             str = "D1";
             break;
        case PERIOD_H4:
             str = "H4";
             break;
        case PERIOD_H1:
             str = "H1";
             break;
        case PERIOD_M30:
             str = "M30";
             break;
        case PERIOD_M15:             
             str = "M15";
             break;
        case PERIOD_M5:
             str = "M5";
             break;                        
        case PERIOD_M1:
            str = "M1";
            break;            
        default:
            str = "UNK";
            break;
    }
    return (str);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  int i;
  string symbol;
  int period;
  string company;  
  double price;
  
  symbol = "XAUUSD"; 
  period = PERIOD_MN1;
                  
//---- 

  if (sv_done < 1) {        
      company = AccountCompany();   
      fetchRates(symbol, period);  
      sv_done = createCSV(StringConcatenate(AccountCompany(),"_",symbol,"_",period2str(period),".csv"));
      Print("OK...");
  } else {
      Print("Skip...");
  }
//----
   return(0);
  }
//+------------------------------------------------------------------+