
#include "Stdafx.h"

#include "mt4_winhttp.h"
#include "helpers.h"
#include "mt4.h"
#include "logger.h"


extern "C" __declspec(dllexport) int winhttp_WinHttpOpen(char * user_agent, int access_type, char * proxy_name, char * proxy_pass, int flags);
extern "C" __declspec(dllexport) int winhttp_WinHttpQueryOptionLen(int resource, int option);
extern "C" __declspec(dllexport) void __winhttp_WinHttpQueryOption(MqlStr *retval, int offset, int resource, int option);
extern "C" __declspec(dllexport) int winhttp_GetLastError();
extern "C" __declspec(dllexport) int winhttp_WinHttpConnect(int resource, char * host, int port);
extern "C" __declspec(dllexport) int winhttp_WinHttpOpenRequest( int resource, char * request_verb, char * request_path, char * http_version, char * http_referrer, int flags);
extern "C" __declspec(dllexport) int winhttp_FlushRequestData(int resource);
extern "C" __declspec(dllexport) int winhttp_AppendRequestData(int resource,char * data);
extern "C" __declspec(dllexport) int winhttp_WinHttpSendRequest(int resource, char * headers);
extern "C" __declspec(dllexport) int winhttp_WinHttpReceiveResponse(int resource); 
extern "C" __declspec(dllexport) int winhttp_WinHttpCloseHandle(int resource);
extern "C" __declspec(dllexport) int winhttp_WinHttpQryDataAvailable(int resource);
extern "C" __declspec(dllexport) int __winhttp_WinHttpReadData(MqlStr * retval, int resource);

int winhttp_WinHttpOpen(char * user_agent, int access_type, char * proxy_name, char * proxy_pass, int flags) 
{
	int ret;
	Logger::getInstance()->logf(LOGGER_DEBUG, "Before mt4_winhttp::winhttp_WinHttpOpen(%s,%d,%s,%s,%d)",user_agent,access_type,proxy_name,proxy_pass,flags);
    mt4_winhttp_client * client = _mt4_winhttp_get_client();
	ret = client->winhttp_WinHttpOpen(user_agent,access_type,proxy_name,proxy_pass,flags); 
	Logger::getInstance()->log(LOGGER_DEBUG, "after mt4_winhttp::winhttp_WinHttpOpen");
	return ret;
}

int winhttp_WinHttpQueryOptionLen(int resource, int option) 
{
	int ret;
	Logger::getInstance()->log(LOGGER_DEBUG, "Before winhttp_WinHttpQueryOptionLen");
	mt4_winhttp_client * client = _mt4_winhttp_get_client();
	ret = client->winhttp_WinHttpQueryOptionLen(resource,option);
	Logger::getInstance()->log(LOGGER_DEBUG, "After winhttp_WinHttpQueryOptionLen");
	return ret;
}

void __winhttp_WinHttpQueryOption(MqlStr * retval, int offset, int resource, int option) 
{
	char * ret;
	Logger::getInstance()->log(LOGGER_DEBUG, "Before winhttp_WinHttpQueryOption");
	mt4_winhttp_client * client = _mt4_winhttp_get_client();
	client->winhttp_WinHttpQueryOption(retval, offset, resource,option);
	Logger::getInstance()->log(LOGGER_DEBUG, "After winhttp_WinHttpQueryOption");	
}

int winhttp_GetLastError() 
{
	int ret;
	Logger::getInstance()->log(LOGGER_DEBUG, "Before winhttp_GetLastError");
    mt4_winhttp_client * client = _mt4_winhttp_get_client();
	ret = client->winhttp_GetLastError();
	Logger::getInstance()->log(LOGGER_DEBUG, "After winhttp_GetLastError");
	return ret;
}

int winhttp_WinHttpConnect(int resource, char * host, int port)
{
	int ret;
	Logger::getInstance()->log(LOGGER_DEBUG, "Before winhttp_WinHttpConnect");
    mt4_winhttp_client * client = _mt4_winhttp_get_client();
	ret = client->winhttp_WinHttpConnect(resource,host,port);
	Logger::getInstance()->log(LOGGER_DEBUG, "After winhttp_WinHttpConnect");
	return ret;
}

int winhttp_WinHttpOpenRequest( int resource, char * request_verb, char * request_path, char * http_version, char * http_referrer,  int flags) 
{
	int ret;
	Logger::getInstance()->log(LOGGER_DEBUG, "Before winhttp_WinHttpOpenRequest");
	mt4_winhttp_client * client = _mt4_winhttp_get_client();
	ret = client->winhttp_WinHttpOpenRequest(resource,request_verb,request_path,http_version, http_referrer, flags);
	Logger::getInstance()->log(LOGGER_DEBUG, "After winhttp_WinHttpOpenRequest");
	return ret;
}

int winhttp_WinHttpSendRequest(int resource, char * headers) 
{
	int ret;
	Logger::getInstance()->log(LOGGER_DEBUG, "Before winhttp_WinHttpSendRequest");
	mt4_winhttp_client * client = _mt4_winhttp_get_client();
	ret = client->winhttp_WinHttpSendRequest(resource,headers);
	Logger::getInstance()->log(LOGGER_DEBUG, "After winhttp_WinHttpSendRequest");
	return ret;
}

int winhttp_WinHttpReceiveResponse(int resource) 
{
	int ret;
	Logger::getInstance()->log(LOGGER_DEBUG, "Before winhttp_WinHttpReceiveResponse");
	mt4_winhttp_client * client = _mt4_winhttp_get_client();
	ret = client->winhttp_WinHttpReceiveResponse(resource);
	Logger::getInstance()->log(LOGGER_DEBUG, "After winhttp_WinHttpReceiveResponse");
	return ret;
}

int winhttp_WinHttpCloseHandle(int resource) 
{
	int ret;
	Logger::getInstance()->log(LOGGER_DEBUG, "Before winhttp_WinHttpCloseHandle");
	mt4_winhttp_client * client = _mt4_winhttp_get_client();
	ret = client->winhttp_WinHttpCloseHandle(resource);
	Logger::getInstance()->log(LOGGER_DEBUG, "After winhttp_WinHttpCloseHandle");
	return ret;
}


int winhttp_WinHttpQryDataAvailable(int resource)
{
	int ret;
	Logger::getInstance()->log(LOGGER_DEBUG, "Before winhttp_WinHttpQueryDataAvailable");
	mt4_winhttp_client * client = _mt4_winhttp_get_client();
	ret = client->winhttp_WinHttpQryDataAvailable(resource);
	Logger::getInstance()->log(LOGGER_DEBUG, "After winhttp_WinHttpQueryDataAvailable");	
	return ret;
}

int __winhttp_WinHttpReadData(MqlStr * retval, int resource)
{
	int ret;
	Logger::getInstance()->log(LOGGER_DEBUG, "Before winhttp_WinHttpReadData");
	mt4_winhttp_client * client = _mt4_winhttp_get_client();
	ret = client->winhttp_WinHttpReadData(retval, resource);
	Logger::getInstance()->log(LOGGER_DEBUG, "After winhttp_WinHttpReadData");	
	return ret;
}

int winhttp_FlushRequestData(int resource)
{
	int ret;
	Logger::getInstance()->log(LOGGER_DEBUG, "Before winhttp_FlushRequestData");
	mt4_winhttp_client * client = _mt4_winhttp_get_client();
	ret = client->winhttp_FlushRequestData(resource);
	Logger::getInstance()->log(LOGGER_DEBUG, "After winhttp_FlushRequestData");	
	return ret;
}

int winhttp_AppendRequestData(int resource,char * data) {
	int ret;
	Logger::getInstance()->log(LOGGER_DEBUG, "Before winhttp_AppendRequestData");
	mt4_winhttp_client * client = _mt4_winhttp_get_client();
	ret = client->winhttp_AppendRequestData(resource, data);
	Logger::getInstance()->log(LOGGER_DEBUG, "After winhttp_AppendRequestData");
	return ret;
}