
#include "Stdafx.h"



#include "logger.h"


Logger::Logger(char * filename) 
{	
	strncpy_s(file_name,LOG_FILENAME_LENGTH_MAX,filename,strlen(filename));
}

char * Logger::LevelToStr(LoggerLogLevel l) {

	char *str;

	switch(l) {
	    case LOGGER_ERROR: 
			str = "ERROR";
			break;
	    case LOGGER_WARNING: 
			str = "WARNING";
			break;
		case LOGGER_INFO:
			str = "INFO";
			break;
		case LOGGER_DEBUG:
			str = "DEBUG";
			break;
	    default:
		    str = "UNKNOWN";
			break;
	}
	return str;
}
void Logger::log(LoggerLogLevel level,char * msg) 
{
     char str[LOG_ENTRY_MAXSIZE];
     time_t now;      
     char dt[LOG_ENTRY_MAXSIZE];
     std::ofstream logfile;		
    
     time(&now); 
	 ctime_s(dt,LOG_ENTRY_MAXSIZE,&now);     
     dt[strlen(dt)-1]='\0';        
    logfile.open(file_name, std::ios::out | std::ios::app);
	sprintf_s(str,LOG_ENTRY_MAXSIZE,"%s [%s] %s\r\n",dt,LevelToStr(level),msg);
	logfile << str;
    logfile.close();	
}

void Logger::logf(LoggerLogLevel level,char * fmt, ...) 
{	
  char str[LOG_ENTRY_MAXSIZE];   
  va_list argptr;
  va_start(argptr,fmt);
  vsnprintf (str, LOG_ENTRY_MAXSIZE, fmt, argptr);
  va_end(argptr);  
  log(level,str);
}



