// This is the main DLL file.

#include "stdafx.h"

#include "mt4_winhttp.h"

#include <string>

//using namespace std;

	mt4_winhttp_client::mt4_winhttp_client() 
	{
		last_error = 0;
		int idx;
		for(idx=0;idx<WINHTTP_MAX_CONNECTIONS;idx++) {
			free_handles[idx] = 1;
			handles_requestdata[idx] = NULL;
		}

		pmb = (char *)malloc( MB_CUR_MAX );

	    have_data_available = false;
	    data_available = 0;

	}


	int mt4_winhttp_client::getMbLen(LPVOID in_str,DWORD len) 
	{

		char *pmb;
		DWORD j;
        const wchar_t* pt;				
		int olen;
		int c;
		
		c = 0;
		pmb = (char *)malloc( MB_CUR_MAX );				
		pt = (wchar_t *)in_str;
		
		for(j=0;j<len;j++) {
		    if (0 == wctomb_s(&olen, pmb,MB_CUR_MAX,*pt)) {
                c += olen;    
			}
			++pt;
		}

		free(pmb);
		return c;
	}
	

    int mt4_winhttp_client::winhttp_WinHttpOpen(char * user_agent, int access_type, char * proxy_name, char * proxy_pass, int flags) 
    {
        // native args

        LPCWSTR pwszUserAgent;
        DWORD dwAccessType;
        LPCWSTR pwszProxyName;
        LPCWSTR pwszProxyBypass;
        DWORD dwFlags;

		// native return arg

        HINTERNET handle;
		
		// storage
		BSTR s_pwszUserAgent;        
        BSTR s_pwszProxyName;
        BSTR s_pwszProxyBypass;


		// local args;
		int hand;

		// get handle

		hand = _get_handle();

		if (hand < 0) {
			last_error = -1;
			return hand;
		}


		// pre-init
		if (NULL == user_agent || 0 == strlen(user_agent)) {			
		    s_pwszUserAgent = L"MT4 WinHTTP/1.0";
		} else {
			s_pwszUserAgent = _str2unicode(user_agent);
		}

		if (NULL == proxy_name || 0 == strlen(proxy_name)) {			
			s_pwszProxyName  = WINHTTP_NO_PROXY_NAME;
		} else {
		    s_pwszProxyName  = _str2unicode(proxy_name);
		}

		if (NULL == proxy_pass || 0 == strlen(proxy_pass)) {
            s_pwszProxyBypass = WINHTTP_NO_PROXY_BYPASS;
		} else {
			s_pwszProxyBypass = _str2unicode(proxy_pass);
		}

		// init args

        pwszUserAgent = s_pwszUserAgent;
        dwAccessType = _accessType2dword(access_type);
        pwszProxyName  = s_pwszProxyName;
        pwszProxyBypass = s_pwszProxyBypass;
        dwFlags = _flags2dword(flags);



		// process request

		handle = WinHttpOpen(pwszUserAgent,dwAccessType,pwszProxyName,pwszProxyBypass,dwFlags);
        
		// process response

		if (handle) {
			handles[hand] = handle;
		} else {
			last_error = GetLastError();
			_free_handle(hand);
			hand = -1;
		}

		if (user_agent != NULL && 0 != strlen(user_agent)) {
           ::SysFreeString(s_pwszUserAgent);
		}
		
		if (proxy_name != NULL && 0 != strlen(proxy_name)) {
	        ::SysFreeString(s_pwszProxyName);
		}

		if (proxy_pass != NULL && 0 != strlen(proxy_pass)) {
	        ::SysFreeString(s_pwszProxyBypass);
		}

		return hand;
    }

    int mt4_winhttp_client::winhttp_WinHttpOpenRequest( 
		int resource, 
		char * request_verb, 
		char * request_path, 
		char * http_version,  
		char * http_referrer,  
		int flags) 
	{
		
        HINTERNET result;

        BSTR s_pwszVerb;
        BSTR s_pwszObjectName;
        BSTR s_pwszVersion;
        BSTR s_pwszReferrer;
		
        HINTERNET hConnect;
        LPCWSTR pwszVerb;
        LPCWSTR pwszObjectName;
        LPCWSTR pwszVersion;
        LPCWSTR pwszReferrer;
        LPCWSTR *ppwszAcceptTypes;
        DWORD dwFlags;
		
		int hand;

		hand = _get_handle();
		if (hand < 0) {
			last_error = -1;
			return hand;
		}

        s_pwszVerb = _str2unicode(request_verb);

        s_pwszObjectName = _str2unicode(request_path);
		
		if (http_version != NULL && strlen(http_version) > 0) {
            s_pwszVersion = _str2unicode(http_version);
		}

		if (http_referrer != NULL && strlen(http_referrer) > 0) {
            s_pwszReferrer = _str2unicode(http_referrer);
		}
        
        hConnect = handles[resource];
        pwszVerb = s_pwszVerb;
        pwszObjectName = s_pwszObjectName;
        pwszVersion = http_version == NULL || 0 == strlen(http_version) ? NULL : s_pwszVersion;
        pwszReferrer = http_referrer == NULL || 0 == strlen(http_referrer) ? WINHTTP_NO_REFERER : s_pwszReferrer;

        ppwszAcceptTypes = WINHTTP_DEFAULT_ACCEPT_TYPES; // how do we do this?
        dwFlags = _flags2dword(flags);

		result = WinHttpOpenRequest(
            hConnect,
            pwszVerb,
            pwszObjectName,
            pwszVersion,
            pwszReferrer,
            ppwszAcceptTypes,
            dwFlags
        );

		if (result) {
			handles[hand] = result;
		} else {
			_free_handle(hand);
			hand = -1;
		}

        ::SysFreeString(s_pwszVerb);
        ::SysFreeString(s_pwszObjectName);
		
		if (http_version != NULL && strlen(http_version) > 0) {
            ::SysFreeString(s_pwszVersion);
		}

		if (http_referrer != NULL && strlen(http_referrer) > 0) {
            ::SysFreeString(s_pwszReferrer);
		}

		return hand;
    }


	int mt4_winhttp_client::winhttp_WinHttpQueryOptionLen(int resource, int option)
	{

	  int ret;
	  
      HINTERNET hInternet;
	  DWORD dwOption;
	  LPVOID lpBuffer;
	  //LPDWORD lpdwBufferLength;
	  LPWSTR s_buffer;
	  DWORD dwSize = sizeof(DWORD);
	  DWORD blen;
	  DWORD dwData;
	  
	  WinhttpDataType optDataType;
	  
	  if (free_handles[resource] == 1) {
		  return 0;
	  }
	  
	  switch(option) {
	      case WINHTTP_OPTION_CONNECT_TIMEOUT:
			  optDataType = WINHTTP_TYPE_UNSIGNED_LONG;
			  break;
		  case WINHTTP_OPTION_URL:
			  optDataType = WINHTTP_TYPE_STRING;
			  break;
		  default:
			  return 0; // unsupported!
	  }

	  switch(optDataType) {
	      case WINHTTP_TYPE_UNSIGNED_LONG:			  
			  s_buffer = new WCHAR[dwSize/sizeof(WCHAR)];
			  blen = dwSize;

	          hInternet = handles[resource];
	          dwOption = _option2dword(option);      


              if (!WinHttpQueryOption(
                  hInternet,
                  dwOption,
                  &dwData,
                  &blen
              )) {	  
		          return 0;
	          }

			  sprintf_s(buffer,WINHTTP_MAX_STRING_LENGTH,"%u",dwData);
			  ret = strlen(buffer);
			  delete s_buffer;
			  break;
		  case WINHTTP_TYPE_STRING:			  
			  s_buffer = new WCHAR[WINHTTP_MAX_STRING_LENGTH];
			  blen = WINHTTP_MAX_STRING_LENGTH;

	          hInternet = handles[resource];
	          dwOption = _option2dword(option);      
			  lpBuffer = s_buffer;

              if (!WinHttpQueryOption(
                  hInternet,
                  dwOption,
                  lpBuffer,
                  &blen
              )) {	  
		          return 0;
	          }
			  						
			  ret = mt4_winhttp_client::getMbLen(lpBuffer,blen);
			  delete s_buffer;
			  break;
	    }
	    				
		return ret;
	}


	char * mt4_winhttp_client::winhttp_WinHttpQueryOption(MqlStr * retval, int offset, int resource, int option)
	{

	  int slen;
	  char *retstr;

      HINTERNET hInternet;
	  DWORD dwOption;
	  LPVOID lpBuffer;
	  //LPDWORD lpdwBufferLength;
	  LPWSTR s_buffer;
	  DWORD dwSize = sizeof(DWORD);
	  DWORD blen;
	  DWORD dwData;

	  WinhttpDataType optDataType;

	  retstr = retval[0].string;

	  //sprintf_s(buffer,WINHTTP_MAX_STRING_LENGTH,"retstr = %s", retstr);
	  //Logger::getInstance()->log(LOGGER_DEBUG, buffer);

	  slen = strlen(retstr);
	  //sprintf_s(buffer,WINHTTP_MAX_STRING_LENGTH,"slen = %d, retval[0].len = %d", slen,retval[0].len);
	  //Logger::getInstance()->log(LOGGER_DEBUG, buffer);

	  if (free_handles[resource] == 1) {
		  return 0;
	  }
	  
	  switch(option) {
	      case WINHTTP_OPTION_CONNECT_TIMEOUT:
			  optDataType = WINHTTP_TYPE_UNSIGNED_LONG;
			  break;
		  case WINHTTP_OPTION_URL:
			  optDataType = WINHTTP_TYPE_STRING;
			  break;
		  default:
			  return 0; // unsupported!
	  }

	  switch(optDataType) {
	      case WINHTTP_TYPE_UNSIGNED_LONG:
			  s_buffer = new WCHAR[dwSize/sizeof(WCHAR)];
			  blen = dwSize;

	          hInternet = handles[resource];
	          dwOption = _option2dword(option);      

              if (!WinHttpQueryOption(
                  hInternet,
                  dwOption,
                  &dwData,
                  &blen
              )) {	  
		          return 0;
	          }

			  sprintf_s(buffer,WINHTTP_MAX_STRING_LENGTH,"%u",dwData);
			  break;
		  case WINHTTP_TYPE_STRING:

			  s_buffer = new WCHAR[WINHTTP_MAX_STRING_LENGTH];
			  blen = WINHTTP_MAX_STRING_LENGTH;

	          hInternet = handles[resource];
	          dwOption = _option2dword(option);      
			  lpBuffer = s_buffer;

              if (!WinHttpQueryOption(
                  hInternet,
                  dwOption,
                  lpBuffer,
                  &blen
              )) {	  
		          return 0;
	          }
			   _unicode2str(lpBuffer,buffer,blen);			  
			  break;
	    }

		//ret = strnlen_s(buffer);
        		
		//Logger::getInstance()->log(LOGGER_DEBUG, buffer);
				
		memcpy_s(retstr,slen, buffer+offset,slen);
		//retval[0].len = slen;
		
		delete s_buffer; 				
		return retval[0].string;
	}



    int mt4_winhttp_client::winhttp_GetLastError()
	{
		return mt4_winhttp_client::last_error;
	}

	int mt4_winhttp_client::winhttp_WinHttpConnect(int resource, char * host, int port) 
	{
		HINTERNET result;
		int hand;

		BSTR s_pswzServerName;
		
        HINTERNET hSession;
        LPCWSTR pswzServerName;
        INTERNET_PORT nServerPort;

		DWORD dwReserved = 0;
		hand = _get_handle();

		if (hand < 0) {
			return hand;
		}

		s_pswzServerName = _str2unicode(host);

		pswzServerName = s_pswzServerName;		
        hSession = handles[resource];
        pswzServerName = s_pswzServerName;
        nServerPort = port;
		
        result = WinHttpConnect(hSession,pswzServerName,nServerPort,dwReserved);

		if (result) {
			handles[hand] = result;
		} else {
            _free_handle(hand);
	        hand = -1;
		}

		::SysFreeString(s_pswzServerName);

		return hand;
	}


    int mt4_winhttp_client::winhttp_WinHttpReceiveResponse(int resource) 
    {
		int ret;

        if (WinHttpReceiveResponse(handles[resource],0)) {
			ret = 1;
		} else {
			ret = 0;
		}
		return ret;
    }

    int mt4_winhttp_client::winhttp_WinHttpSendRequest(
		int resource, 
		char * headers) 
    {
		int ret;
        BSTR s_pwszHeaders;
        
		char * data;
				
        LPCWSTR pwszHeaders;
        DWORD dwHeadersLength;
        LPVOID lpOptional;
        DWORD dwOptionalLength;
        DWORD dwTotalLength;
        DWORD_PTR dwContext;
		
		
		if (headers == NULL || 0 == strlen(headers)) {
			pwszHeaders = WINHTTP_NO_ADDITIONAL_HEADERS;
			dwHeadersLength = 0;
			Logger::getInstance()->log(LOGGER_DEBUG, "No additional headers");
		} else {
		    s_pwszHeaders = _str2unicode(headers);
            pwszHeaders = s_pwszHeaders;			
		    sprintf_s(buffer,WINHTTP_MAX_STRING_LENGTH,"Headers = %s",headers);
			Logger::getInstance()->log(LOGGER_DEBUG, buffer);
			dwHeadersLength = strlen(headers); // probably a bug here...
		}
        
		
		if (handles_requestdata[resource] == NULL) {
			lpOptional = WINHTTP_NO_REQUEST_DATA;
			dwOptionalLength = 0;
		} else {
			data = new char[handles_requestdata[resource]->length() + 1];
			std::strcpy(data,handles_requestdata[resource]->c_str());
            lpOptional = (void *)data; // encoding here may not be correct
            dwOptionalLength = strlen(data);
		}

        dwTotalLength = dwOptionalLength;
        dwContext = 0;

        if (WinHttpSendRequest(handles[resource],pwszHeaders,dwHeadersLength,lpOptional,dwOptionalLength,dwTotalLength,dwContext)) {
			ret = 1;
			last_error = 0;
		} else {
			last_error = GetLastError();
			ret = 0;
		}

		if (headers != NULL && strlen(headers) > 0) {
		    ::SysFreeString(s_pwszHeaders);
		}

		if (handles_requestdata[resource] != NULL) {
			delete data;
		}

		return ret;        
    }

    int mt4_winhttp_client::winhttp_WinHttpCloseHandle(int resource) 
    {
		int ret;

		if (WinHttpCloseHandle(handles[resource])) {
			ret = 1;
		} else {
			ret = 0;
		}

		_free_handle(resource);

		return ret;
    }

	int mt4_winhttp_client::winhttp_WinHttpQryDataAvailable(int resource) 
	{
		DWORD dwSize = 0;
		
		last_error = 0;

		if (!have_data_available) {		   		
			data_available = 0;
			data_available_offset = 0;

	        if (!WinHttpQueryDataAvailable(handles[resource],&dwSize)) {
                 last_error = GetLastError();				 
				 data_available = -1;
		    } else {
				
				sprintf_s(buffer,WINHTTP_MAX_STRING_LENGTH,"Data available = %u",dwSize);
				Logger::getInstance()->log(LOGGER_DEBUG, buffer);

                data_available_buffer = new char[dwSize+1];
				ZeroMemory(data_available_buffer, dwSize+1);

                if (!WinHttpReadData( handles[resource], (LPVOID)data_available_buffer, 
                                      dwSize, &data_available_downloaded)) {
				    last_error = GetLastError();					
					data_available = -2;
                    delete [] data_available_buffer;					
				} else {

				    sprintf_s(buffer,WINHTTP_MAX_STRING_LENGTH,"Downloaded Words = %u",data_available_downloaded);
				    Logger::getInstance()->log(LOGGER_DEBUG, buffer);

					have_data_available = true;
                    //_unicode2str((LPVOID)data_available_buffer, buffer,data_available_downloaded);
					data_available = strlen(data_available_buffer);
					data_available_offset = 0;
				}
			}
		}
        return data_available;
	}

	int mt4_winhttp_client::winhttp_WinHttpReadData(MqlStr * retval, int resource) 
	{
		int ret;
		int retstr_len;
		char * retstr;
		char * bp;

		retstr = retval[0].string;
		retstr_len = strlen(retstr);

		if (!have_data_available) {
			winhttp_WinHttpQryDataAvailable(resource);
		}

		if (!have_data_available) {
			// error condition?
	        ret = -1;
	    } else {
			//_unicode2str((LPVOID)data_available_buffer, buffer,data_available_downloaded);
			bp = data_available_buffer;

			if (data_available > retstr_len) {
				memcpy_s(retstr,retstr_len,bp+data_available_offset,retstr_len);
				data_available -= retstr_len;
				data_available_offset += retstr_len;
				ret = retstr_len;
			} else {
				memcpy_s(retstr,retstr_len,bp+data_available_offset,retstr_len);				
				ret = data_available;
				data_available = 0;
				data_available_offset = 0;
				have_data_available = false;
				delete [] data_available_buffer;
			}
		}
		return ret;
	}


int mt4_winhttp_client::winhttp_FlushRequestData(int resource) 
{
	int ret = 1;
	if (handles_requestdata[resource] != NULL) {
		delete  handles_requestdata[resource];
		handles_requestdata[resource] = NULL;			
    }
	return ret;
}

int mt4_winhttp_client::winhttp_AppendRequestData(int resource,char * data) 
{
	int ret = 1;
    std::string *s1,*s2;
	
	if (handles_requestdata[resource] == NULL) {
		handles_requestdata[resource] = new std::string(data);
	} else {
		s1 = handles_requestdata[resource];
		s2 = new std::string(data);		
		handles_requestdata[resource] = new std::string(*s1 + *s2);		 
		delete s2;
		delete s1;
	}
	return ret;
}