// mt4_winhttp.h

#pragma once

#include "windows.h"
#include "winhttp.h"
#include "config.h"
#include "mt4.h"
#include "logger.h"

#include <stdlib.h>
#include <stdio.h>


enum WinhttpDataType {
	WINHTTP_TYPE_UNSIGNED_LONG,
	WINHTTP_TYPE_STRING,
	WINHTTP_TYPE_UNKNOWN
};

public class mt4_winhttp_client
{
	int free_handles[WINHTTP_MAX_CONNECTIONS];
	int last_error;

	bool have_data_available;
	int data_available;
	int data_available_offset;

	LPSTR data_available_buffer;
	DWORD data_available_downloaded;

	HINTERNET handles[WINHTTP_MAX_CONNECTIONS];

	std::string * handles_requestdata[WINHTTP_MAX_CONNECTIONS];

	char buffer[WINHTTP_MAX_STRING_LENGTH];

	char *pmb;

	DWORD _flags2dword(int flag) 
	{
		return (DWORD)flag;
	}

	DWORD _accessType2dword(int access_type) 
	{
		return (DWORD)access_type;
	}

	DWORD _option2dword(int option) 
	{
		return (DWORD)option;
	}
    
	BSTR _str2unicode(char * str) 
	{
	    int a;
	    BSTR unicodestr;

		if (NULL == str) return NULL;

	    a = lstrlenA(str);
        unicodestr = SysAllocStringLen(NULL, a);
        ::MultiByteToWideChar(CP_ACP, 0, str, a, unicodestr, a);
	    return unicodestr;
    }
	
	void _unicode2str(LPVOID in_str, char * out_str,DWORD len) 
	{
        const wchar_t* pt;				
		int len2;
		int i;
		int idx = 0;
		
		DWORD j;
		pt = (wchar_t *)in_str;
		
		for(j=0;j<len;j++) {		
		    if (0 == wctomb_s(&len2, pmb,10,*pt)) {
			    for (i=0;i<len2;i++) {
			        out_str[idx++] = pmb[i];
			    }
			}
			++pt;
		}    
    }

	int getMbLen(LPVOID in_str, DWORD len);

	int _get_handle() 
	{
		int idx;
		for(idx=0;idx<WINHTTP_MAX_CONNECTIONS;idx++) {
			if (free_handles[idx] == 1) {
				free_handles[idx] = 0;
				return idx;
			}
		}
		return -1;
	}

	void _free_handle(int handle) 
	{		
		if (handles_requestdata[handle] != NULL) {
			delete  handles_requestdata[handle];
			handles_requestdata[handle] = NULL;			
		}		
		free_handles[handle] = 1;
	}

public:

	mt4_winhttp_client();
	int mt4_winhttp_client::winhttp_WinHttpOpen(char * user_agent, int access_type, char * proxy_name, char * proxy_pass, int flags);
	int winhttp_GetLastError();
	int winhttp_WinHttpQueryOptionLen(int resource, int option);
	char * winhttp_WinHttpQueryOption(MqlStr * retval, int offset, int resource, int option);
	int winhttp_WinHttpConnect(int resource, char * host, int port); 
	int winhttp_WinHttpOpenRequest( int resource, char * request_verb, char * request_path, char * http_version, char * http_referrer,  int flags);
    int winhttp_WinHttpSendRequest(int resource, char * headers);
	int winhttp_WinHttpReceiveResponse(int resource);
	int winhttp_WinHttpCloseHandle(int resource);

	int winhttp_WinHttpQryDataAvailable(int resource);
	int winhttp_WinHttpReadData(MqlStr * retval, int resource);

    int winhttp_FlushRequestData(int resource);
    int winhttp_AppendRequestData(int resource,char * data);

};
